﻿using System;
using System.Collections.ObjectModel;
using System.Linq;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            ReadOnlyCollection<TimeZoneInfo> collection = TimeZoneInfo.GetSystemTimeZones();

            this.listBox.Items.AddRange(collection.ToArray());

            Load            += Form_Load;
            this.timer.Tick += timer_Tick;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 폼 로드시 처리하기 - Form_Load(sender, e)

        /// <summary>
        /// 폼 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Form_Load(object sender, EventArgs e)
        {
            int index = this.listBox.Items.IndexOf(TimeZoneInfo.FindSystemTimeZoneById("Korea Standard Time"));

            this.listBox.SetSelected(index, true);
        }

        #endregion
        #region 타이머 틱 처리하기 - timer_Tick(sender, e)

        /// <summary>
        /// 타이머 틱 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void timer_Tick(object sender, EventArgs e)
        {
            TimeZoneInfo timeZoneInfo = (TimeZoneInfo)this.listBox.SelectedItem;

            this.currentTimeZoneLabel.Text = $"{this.listBox.Text} : {TimeZoneInfo.ConvertTime(DateTime.Now, timeZoneInfo).ToString()}";
        }

        #endregion
    }
}